import { TypedEmitter } from "tiny-typed-emitter";
import { Service, ServiceConfiguration, ServiceDirection } from "@cross-lab-project/soa-client";
import { DataChannel } from "@cross-lab-project/soa-client";
import { PeerConnection } from "@cross-lab-project/soa-client";
type ServiceType = "goldi/file";
declare const ServiceType: ServiceType;
export interface FileServiceConfiguration extends ServiceConfiguration {
    serviceType: ServiceType;
}
export declare enum FileType {
    "Hex" = 0,
    "Elf" = 1
}
export interface ReceiveFileEvent {
    file: Uint8Array;
}
export interface File {
    fileType: FileType;
    content: Uint8Array;
}
export interface FileInterfaceEvents {
    receiveHex(event: ReceiveFileEvent): void;
    receiveElf(event: ReceiveFileEvent): void;
}
declare abstract class FileService extends TypedEmitter<FileInterfaceEvents> implements Service<ServiceType> {
    serviceType: "goldi/file";
    abstract serviceDirection: ServiceDirection;
    serviceId: string;
    constructor(serviceId: string);
    getMeta(): {
        serviceId: string;
        serviceType: "goldi/file";
        serviceDirection: ServiceDirection;
    };
    abstract setupConnection(connection: PeerConnection, serviceConfig: ServiceConfiguration): void;
}
/**
 * - maybe it would also suffice to just use the Prosumer ServiceDirection
 * - maybe move sendFile function to an interface
 */
export declare class FileService__Producer extends FileService {
    serviceDirection: ServiceDirection;
    channel?: DataChannel;
    setupConnection(connection: PeerConnection, serviceConfig: ServiceConfiguration): void;
    sendFile(file: File): Promise<void>;
}
export declare class FileService__Consumer extends FileService {
    serviceDirection: ServiceDirection;
    setupConnection(connection: PeerConnection, serviceConfig: ServiceConfiguration): void;
    private header;
    handleData(data: string | Blob | ArrayBuffer | ArrayBufferView): void;
}
export {};
//# sourceMappingURL=file.d.ts.map